const ack_codes = {
    "SMAC_ACK_CODE_SUCCESS":			 "0",
    "SMAC_ACK_CODE_ERROR":				 "1",
    "SMAC_ACK_CODE_INVALID_PIN":		 "2",
    "SMAC_ACK_CODE_LIMIT_EXCEED":		 "3",
    "SMAC_ACK_INVALID_ID_DEVICE":          "4",
    "SMAC_ACK_INVALID_WIFI_SSID":               "5",
    "SMAC_ACK_INVALID_WIFI_PASSWORD":           "6",
    "SMAC_ACK_CONN_TIMEOUT":                    "7",
    "SMAC_ACK_INVALID_NAME_PROPERTY":           "8",
    "SMAC_ACK_INVALID_NAME_TOPIC":              "9",
    "SMAC_ACK_INVALID_SCHE_START_HOUR":         "A",
    "SMAC_ACK_INVALID_SCHE_START_MIN":          "B",
    "SMAC_ACK_INVALID_SCHE_STOP_HOUR":          "C",
    "SMAC_ACK_INVALID_SCHE_STOP_MIN":           "D",
    "SMAC_ACK_INVALID_IN_TYPE":                 "E",
    "SMAC_ACK_INVALID_MAX_ON_TIME":             "F",
    "SMAC_ACK_INVALID_PROP_VISIBLE":            "G",
    "SMAC_ACK_INVALID_AP_SSID":                 "H",
    "SMAC_ACK_INVALID_AP_PASSWORD":             "I",
    "SMAC_ACK_INVALID_BUZ_SOUND_ON":            "J",
    "SMAC_ACK_INVALID_BUZ_SOUND_OFF":           "K",
    "SMAC_ACK_INVALID_USERNAME":                "L",
    "SMAC_ACK_INVALID_USER_PWD":                "M",
}

const smac_keys = {"SMAC_DEVICE_COMPUTER":"0",
"SMAC_DEVICE_SMART_PHONE":"1",
"SMAC_DEVICE_ESP32"		:			"2",
"SMAC_DEVICE_RPI"		:				"3",
"SMAC_PROP_SWITCH"		:			"00",
"SMAC_PROP_FAN"		:				"01",
"SMAC_PROP_LIGHT"		:				"02",
"SMAC_PROP_AC"		:				"03",
"SMAC_PROP_GEYSER"		:			"04",
"SMAC_PROP_BLUETOOTH"	:				"05",
"SMAC_BATTERY"		:				"06",
"SMAC_FLASH"		:					"07",
"SMAC_SHUTDOWN"		:				"08",
"SMAC_RESTART"		:				"09",
"SMAC_BRIGHTNESS"		:				"0A",


"SMAC_CMD_SET_PROPERTY"		:		"A0",
"SMAC_CMD_SET_PROPERTY_ACK":		"A1",
"SMAC_CMD_STATUS":		"A2",
"SMAC_CMD_REQ_SEND_INFO":		"A3",
"SMAC_CMD_SEND_INFO":		"A4",
"SMAC_FROM":"A5",
"SMAC_TO":"A6",
"SMAC_COMMAND":"A7",
"SMAC_CMD_ACK":"A8",
"SMAC_ID_MESSAGE":"A9",
"SMAC_MESSAGE":"AA",
"SMAC_SSID_WIFI":"AB",
"SMAC_NAME_WIFI":"AC",
"SMAC_NAME_TOPIC":"AD",
"SMAC_ID_TOPIC":"AE",
"SMAC_ID_DEVICE":"AF",
"SMAC_NAME_DEVICE":"AG",
"SMAC_TYPE_DEVICE":"AH",
"SMAC_LOCATION_WIFI":"AI",
"SMAC_ID_PROPERTY":"AJ",
"SMAC_TYPE_PROPERTY":"AK",
"SMAC_NAME_PROPERTY":"AL",
"SMAC_VALUE":"AM",
"SMAC_VALUE_MIN":"AN",
"SMAC_VALUE_MAX":"AO",
"SMAC_VALUE_STEP":"AP",
"SMAC_VALUE_UNIT":"AQ",
"SMAC_CMD_INIT_SEND_INFO":                 "AR",
"SMAC_CMD_END_SEND_INFO":                  "AS",
"SMAC_CMD_STATUS_SET_PROPERTY":            "AT",
"SMAC_CMD_STATUS_ADD_TOPIC":                "AU",
"SMAC_CMD_STATUS_REMOVE_TOPIC":             "AV",
"SMAC_CMD_ADD_TOPIC":                       "AW",
"SMAC_CMD_REMOVE_TOPIC":                    "AX",
"SMAC_PASSKEY":                             "AY",
"SMAC_CMD_DEVICE_BUSY":                     "AZ",
"SMAC_CMD_INVALID_PIN":                     "Aa",
"SMAC_NAME_HOME":                           "Ab",
"SMAC_CMD_UPDATE_WIFI_CONFIG":              "Ac",
"SMAC_SSID":                                "Ad",
"SMAC_PASSWORD":                            "Ae",
"SMAC_CMD_ONLINE":                          "Af",
"SMAC_CMD_UPDATE_SOFTWARE":                 "Ag",
"SMAC_CMD_UPDATE_INTERVAL_ONLINE":          "Ah",
"SMAC_INTERVAL":                            "Ai",
"SMAC_CMD_STATUS_UPDATE_WIFI_CONFIG":       "Aj",
"SMAC_CMD_STATUS_UPDATE_INTERVAL_ONLINE":   "Ak",
"SMAC_CMD_UPDATE_NAME_DEVICE":              "Al",
"SMAC_CMD_STATUS_UPDATE_NAME_DEVICE":       "Am",
"SMAC_CMD_UPDATE_NAME_PROPERTY":            "An",
"SMAC_CMD_STATUS_UPDATE_NAME_PROPERTY":     "Ao",
"SMAC_CMD_TOPIC_LIMIT_EXCEEDED":            "Ap",
"SMAC_CMD_STATUS_UPDATE_SOFTWARE":          "Aq",
"SMAC_CMD_ADD_ACTION":                      "Ar",
"SMAC_CMD_REMOVE_ACTION":                   "As",
"SMAC_CMD_ADD_TRIGGER":                     "At",
"SMAC_CMD_REMOVE_TRIGGER":                  "Au",
"SMAC_CMD_STATUS_ADD_ACTION":               "Av",
"SMAC_CMD_STATUS_REMOVE_ACTION":            "Aw",
"SMAC_CMD_STATUS_ADD_TRIGGER":              "Ax",
"SMAC_CMD_STATUS_REMOVE_TRIGGER":           "Ay",
"SMAC_CMD_ACTION_LIMIT_EXCEEDED":           "Az",
"SMAC_CMD_TRIGGER_LIMIT_EXCEEDED":          "B0",
"SMAC_CMD_STATUS_ADD_CONTEXT":              "B1",
"SMAC_CMD_STATUS_REMOVE_CONTEXT":           "B2",
"SMAC_CONTEXT_ACTION":                      "B3",
"SMAC_CONTEXT_TRIGGER":                     "B4",
"SMAC_CONTEXT":                             "B5",
"SMAC_TOPIC":                               "B6",
"SMAC_PROPERTY":                            "B7",
"SMAC_ID_CONTEXT":                          "B8",
"SMAC_NAME_CONTEXT":                        "B9",
"SMAC_TYPE_TRIGGER_PROP":                   "BA",
"SMAC_TYPE_TRIGGER_TIME":                   "BB",
"SMAC_TYPE_TRIGGER_LOCATION":               "BC",
"SMAC_TYPE_TRIGGER":                        "BD",
"SMAC_CMD_TRIGGER_CONTEXT":                 "BE",
"SMAC_ID":     								"BF",
"SMAC_VALUE_TEMP":     						"BG",
"SMAC_IS_BUSY":     						"BH",
"SMAC_BUSY_PERIOD":     					"BI",
"SMAC_INTERVAL_ONLINE":     				"BJ",
"SMAC_REMOVE":      						"BK",
"SMAC_PIN_DEVICE":     						"BL",
"SMAC_STATUS":     							"BM",
"SMAC_COMPARATOR":     						"BN",
"SMAC_LAST_UPDATED":     					"BO",
"SMAC_CMD_SAVE_CONTEXT": 					"BP",
"SMAC_CMD_SET_PIN_DEVICE": 					"BQ",
"SMAC_CMD_SET_PIN_DEVICE_ACK": 					"BR",
"SMAC_CMD_CONFIG_DATA": 								"BS",
"SMAC_CMD_CONFIG_CHECK_SW_UPDATE": 				"BT",
"SMAC_CMD_CONFIG_SW_UPDATE_STATUS": 		"BU",
"SMAC_OTA_STATUS": 							"BV",
"SMAC_CMD_SET_DEBUG": 							"BW",
"SMAC_CMD_SET_DEBUG_ACK": 						"BX",
"SMAC_DEBUG": 								"BY",
"SMAC_CMD_SET_BUZZER_SOUND": 							"BZ",
"SMAC_CMD_SET_BUZZER_SOUND_ACK": 						"Ba",
"SMAC_EN_BUZZER_SOUND": 								"Bb",
"SMAC_CMD_DEBUG_MSG": 						"Bc",
"SMAC_CMD_SET_IN_TYPE": 					"Bd",
"SMAC_CMD_SET_IN_TYPE_ACK": 				"Be",
"SMAC_IN_TYPE": 							"Bf",
"SMAC_WIFI_SIG_STRENGTH": 					"Bg",
"SMAC_FREE_RAM": 							"Bh",
"SMAC_CMD_GET_CONFIG_DATA":			"Bi",
"SMAC_PROP_MAX_ON_TIME":                    "Bj",
"SMAC_CMD_SET_PROP_MAX_ON_TIME":			 "Bk",
"SMAC_CMD_STATUS_SET_PROP_MAX_ON_TIME":	 "Bl",
//"SMAC_SERVER":                              "2D",
"SMAC_CMD_SET_SERVER":			 "Bm",
"SMAC_CMD_STATUS_SET_SERVER":	 "Bn",
"SMAC_SEND_ACK":                 "Bo",
"SMAC_ACK_CODE":				 "Bp",
"SMAC_IP_ADDR"              :    "Bq",
"SMAC_ST_IPADDR"            :    "Br",
"SMAC_USERNAME":				    "Bs",
"SMAC_TOKEN":					 "Bt",
"SMAC_SERVER":				 "Bu",
"SMAC_SERVER_PORT":				 "Bv",
"SMAC_SERVER_USERNAME":			 "Bw",
"SMAC_SERVER_PASSWORD":        "Bx",
"SMAC_CMD_UPDATE_USERNAME_PWD":	"By",
"SMAC_USER_PWD":                "Bz",
"SMAC_OTP"          :           "C0",
"SMAC_BOARD"	    :"C1",
"SMAC_CMD_UPDATE_NAME_TOPIC": "C2",
"SMAC_CMD_VISIBLE_PROPERTY": "C3",
"SMAC_PROP_VISIBLE": "C4",
"SMAC_CMD_UPDATE_TYPE_PROPERTY": "C5",
"SMAC_CMD_GET_DEBUG_MSG": "C6",
"SMAC_CMD_SET_BUZZER_SOUND_PROP" :	 "C7",
"SMAC_BUZZER_SOUND_PROP_ON":    "C8",
"SMAC_BUZZER_SOUND_PROP_OFF":    "C9",
"SMAC_CMD_PLAY_SOUND":    "CA",
"SMAC_BUZZER_SOUND":    "CB",
"SMAC_AP_SSID": "CC",
"SMAC_AP_PWD": "CD",
"SMAC_CMD_UPDATE_AP_CONFIG": "CE",
"SMAC_CMD_DEVICE_RESTART": "CF",
"SMAC_CMD_WIFI_AP_RECORD" :"CG",
"SMAC_CMD_CONNECT_WIFI": "CH",
"SMAC_WIFI_CHANNEL": "CI",
"SMAC_WIFI_RSSI": "CJ",
"SMAC_WIFI_AUTH_MODE": "CK",
"SMAC_CMD_GET_WIFI_AP_RECORD": "CL",
"SMAC_RESTART": "CM",
"SMAC_SECURE": "CN",
"SMAC_CMD_EN_CONFIG_MODE": "CO",
"SMAC_WIFI_SCAN_LIST":"CP",
"SMAC_CMD_STATUS_PROPERTY":"CQ",
"SMAC_CMD_GET_DEVICE_STAT": "CR",
"SMAC_CMD_DEVICE_STAT": "CS",
"SMAC_CMD_SET_SCHEDULE_TIME": "CT",
"SMAC_SCHEDULE_START_HOUR": "CU",
"SMAC_SCHEDULE_START_MINUTE": "CV",
"SMAC_SCHEDULE_STOP_HOUR": "CW",
"SMAC_SCHEDULE_STOP_MINUTE": "CX",
"SMAC_PROP_TIMER_TYPE": "CY",
"SMAC_CMD_GET_PROP_INFO" :"CZ",
"SMAC_CMD_PROP_INFO" :"Ca",
"SMAC_SECRET_KEY": "Cb",
"SMAC_EMAIL": "Cc",
"SMAC_CMD_SET_SCHEDULE_EN": "Cd",
"SMAC_SCHEDULE_EN": "Ce"
}