const MAX_WIFI_CONN_TIMEOUT  = 30;
const MIN_LEN_WIFI_SSID =      8;
const MAX_LEN_WIFI_SSID  =     32;
const MIN_LEN_WIFI_PASSWORD =  8;
const MAX_LEN_WIFI_PASSWORD =  32;
const MIN_LEN_AP_SSID  =       8;
const MAX_LEN_AP_SSID  =       64;
const MIN_LEN_AP_PASSWORD =    8;
const MAX_LEN_AP_PASSWORD =    32;
const MIN_LEN_USERNAME   =     8;
const MAX_LEN_USERNAME   =     64;
const MIN_LEN_USER_PWD   =     8;
const MAX_LEN_USER_PWD   =     32;
const MIN_LEN_NAME_TOPIC  =         3;
const MAX_LEN_NAME_TOPIC  =         32;
const MIN_LEN_NAME_PROPERTY =       3;
const MAX_LEN_NAME_PROPERTY =       32;
const MIN_LEN_PIN_DEVICE    =       4;
const MAX_LEN_PIN_DEVICE    =       6;


const MAX_HOURS = 24;

const isNum = function(num) {
    return /^\d+$/.test(num);
}
const isStr = function(str) {
    return /[a-zA-Z]/.test(str);
}
const containsSpecailChars = function(str) {
    //return /[!@#$%^&*()_+\-=\[\]{};':"\\|,.<>\/?]+/.test(str);
    // without underscore
    return /[!@#$%^&*()+\-=\[\]{};':"\\|,.<>\/?]+/.test(str);
}

function validateSoundVal(val) {
    if( val > 1 ) {
        return false;
    }
    return true;
}

function validateScheduleEn(val) {
    if( val > 1 ) {
        return false;
    }
    return true;
}

function validateMaxOntime(val) {
    if (val < 0 || val > 59) {
        return false;
    }
    return true;
}

function validateHour(val) {
    if (val < 0 || val > MAX_HOURS - 1) {
        return false;
    }
    return true;
}

function validateMinute(val) {
    if (val < 0 || val > 59) {
        return false;
    }
    return true;
}

function validateNameProperty(nameProperty) {
    if(nameProperty == null) {
        return false;
    }

    const len = nameProperty.length;
    if (len < MIN_LEN_NAME_PROPERTY || len > MAX_LEN_NAME_PROPERTY) {
        return false;
    }
    if (!/^[a-zA-Z]/.test(nameProperty)) {
        return false;
    }
    return true;
}

function validateNameTopic(nameTopic) {
    if(nameTopic == null) {
        return false;
    }

    const len = nameTopic.length;
    if (len < MIN_LEN_NAME_TOPIC || len > MAX_LEN_NAME_TOPIC) {
        return false;
    }
    return true;
}


function validateApSsid(ssid) {
    if(ssid == null) {
        return false;
    }

    const len = ssid.length;
    if (len < MIN_LEN_AP_SSID || len > MAX_LEN_AP_SSID) {
        return false;
    }
    return true;
}

function validateApPassword(password) {
    if(password == null) {
        return false;
    }

    const len = password.length;
    if (len < MIN_LEN_AP_PASSWORD || len > MAX_LEN_AP_PASSWORD) {
        return false;
    }
    return true;
}

function validateStSsid(ssid) {
    if(ssid == null) {
        return false;
    }

    const len = ssid.length;
    if (len < MIN_LEN_WIFI_SSID || len > MAX_LEN_WIFI_SSID) {
        return false;
    }
    return true;
}

function validateStPassword(password) {
    if(password == null) {
        return false;
    }

    const len = password.length;
    if (len < MIN_LEN_WIFI_PASSWORD || len > MAX_LEN_WIFI_PASSWORD) {
        return false;
    }
    return true;
}

function validateUsername(username) {
    if(username == null) {
        return false;
    }

    const len = username.length;

    // Check length
    if (len < MIN_LEN_USERNAME || len > MAX_LEN_USERNAME) {
        return false;
    }

    return true; // Username is valid
}

function validateUserPwd(password) {
    if(password == null) {
        return false;
    }

    const len = password.length;

    // Check length
    if (len < MIN_LEN_USER_PWD || len > MAX_LEN_USER_PWD) {
        return false;
    }

    return true;
}